//---------------------------------------------------------------------------
#ifndef analyseH
#define analyseH
//---------------------------------------------------------------------------
#include "base.h"
//---------------------------------------------------------------------------
// pour asErreur
#define NBMSGERR 14
#define ERR_AUCUNE 0 // Le reste dfini dans analyse.cpp
// pour asTypeMsgAnalyse
#define NBTYPESMSGANALYSE 2
#define TMA_LEXSYN 0
#define TMA_SEM    1
// pour les arguments bool Question et asCibleAnalyse
#define NBCIBLESANALYSE 2
#define CA_BASE         0
#define CA_QUESTION     1
//---------------------------------------------------------------------------
class base; // base.h
class recherche; // base.h
//---------------------------------------------------------------------------
class analyse
 {
  private:
  recherche *Recherche;
  bool PasseCaractereSuivant(int &Pos);
  bool PasseSeparateurs(int &Pos);
  bool EstIdentificateurReglePredefinie(int &Pos, AnsiString &asIdentificateur);
  bool EstIdentificateur(int &Pos, type_identificateur &Type, AnsiString &asIdentificateur);
  bool EstArgument(int &Pos, argument *Argument);
  bool EstPartieArguments(int &Pos, argument **Arguments); // Pr-requis : NE PAS CREER Arguments  l'appel
  bool EstContrainte(int &Pos, contrainte *Contrainte); // Pr-requis : Contrainte doit tre cr avant
  bool EstPartieContraintes(int &Pos, bool &DerniereRegle, definition *Definition, bool Question);
  bool EstDefinitionRegle(int &Pos, bool &DerniereRegle, regle *Regle);
  public:
  int NumErreur, PosErreur;
  AnsiString asSource, asPrmErreur;
  ~analyse() {};
  void Initialise()
   {
    Recherche=NULL;
    NumErreur=0;
    PosErreur=0;
   };
  //-- ANALYSE DE BASE (LISTE DE REGLES) ------------------------------------
  analyse(const AnsiString asSource) { Initialise(); this->asSource=asSource; };
  bool EstListeRegles();
  bool IdentifieReglesBase();
  //-- ANALYSE DE RECHERCHE (QUESTION)---------------------------------------
  analyse(recherche *Recherche, const AnsiString asSource) { Initialise(); this->Recherche=Recherche; this->asSource=asSource; };
  bool EstQuestion();
  bool IdentifieReglesRecherche();
 };
//---------------------------------------------------------------------------
extern const AnsiString asErreur[NBMSGERR],
                        asCibleAnalyse[NBCIBLESANALYSE],
                        asTypeMsgAnalyse[NBTYPESMSGANALYSE];
//---------------------------------------------------------------------------
#endif
