//---------------------------------------------------------------------------
#ifndef arbreH
#define arbreH
//---------------------------------------------------------------------------
#ifdef PRFD_WINDOWS
#include <ComCtrls.hpp>
#endif
//---------------------------------------------------------------------------
#ifdef PRFD_LINUX
#include <QComCtrls.hpp>
#endif
//---------------------------------------------------------------------------
#include "analyse.h"
//---------------------------------------------------------------------------
#define IDB_BASE           0
#define IDB_REGLEDEFN      1
#define IDB_REGLECNTR      2
#define IDB_REGLEPRDF      3
#define IDB_SIGNATURE      4
#define IDB_DEFINITION     5
#define IDB_CONTRAINTE     6
#define IDB_ARGUMENTDEFN   7
#define IDB_ARGUMENTCNTR   8
#define IDB_ELEMENTDECL    9
#define IDB_ELEMENTDEFN   10
#define IDB_ELEMENTCNTR   11
#define IDB_VARIABLEDECL  12
#define IDB_VARIABLEDEFN  13
#define IDB_VARIABLECNTR  14
#define IDB_RECHERCHE     15
#define IDB_QUESTION      16
#define IDB_REPONSE       17
#define IDB_TRACE         18
#define IDB_SOLUTION      19
#define IDB_VARIABLEETAT  20
#define IDB_ECHEC         21
#define IDB_REUSSITE      22
#define IDB_STOPECHEC     23
#define IDB_STOPREUSSITE  24
#define IDB_AVERTISSEMENT 25 // LE LAISSER A LA FIN DE LA LISTE
//---------------------------------------------------------------------------
// pour asLibelleNoeud
#define NBTYPESNOEUD   11
#define ND_BASE         0
#define ND_REGLES       1
#define ND_REGLESPRDF   2
#define ND_SIGNATURES   3
#define ND_DEFINITIONS  4
#define ND_CONTRAINTES  5
#define ND_ARGUMENTS    6
#define ND_ELEMENTS     7
#define ND_VARIABLES    8
#define ND_RECHERCHE    9
#define ND_QUESTION    10
//---------------------------------------------------------------------------
class contrainte; // base.h
class definition; // base.h
class regle; // base.h
//---------------------------------------------------------------------------
class arbre
 {
  bool Numerotation;
  recherche *Recherche;
  TTreeView *TreeView;
  void MontreAvertissements(TTreeNode *TreeNode);
  public:
  int NbAvertissements;
  void Initialise() { Numerotation=false; Recherche=NULL; NbAvertissements=0; TreeView=NULL; };
  arbre(TTreeView *TreeView)
   {
    Initialise();
    this->TreeView=TreeView;
   };
  arbre(recherche *Recherche, TTreeView *TreeView, bool Numerotation)
   {
    Initialise();
    this->Numerotation=Numerotation;
    this->Recherche=Recherche;
    this->TreeView=TreeView;
    this->Recherche->Arbre=this; // On sauvegarde l'instance pour son utilisation lors de la recherche
   };
  TTreeNode *arbre::CreeRacine(const AnsiString asLibelleNoeud, int IndexImage, void *Donnee);
  TTreeNode *CreeNoeud(TTreeNode *TreeNodeSrc, const AnsiString asLibelleNoeud, int IndexImage, void *Donnee);
  void CreeArbre(contrainte *Contrainte, TTreeNode *TreeNodeContraintes);
  void CreeArbre(definition *Definition, TTreeNode *TreeNodeDefinitions);
  void CreeArbre(signature *Signature, TTreeNode *TreeNodeSignatures);
  void CreeArbre(regle *Regle, TTreeNode *TreeNodeRegles);
  void CreeArbre(TStatusBar *StatusBar);
  void MontreAvertissements();
 };
//---------------------------------------------------------------------------
extern const AnsiString asLibelleNoeud[NBTYPESNOEUD];
//---------------------------------------------------------------------------
#endif


