//---------------------------------------------------------------------------
#ifndef baseH
#define baseH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
#ifdef PRFD_WINDOWS
#include <ComCtrls.hpp>
#endif
//---------------------------------------------------------------------------
#ifdef PRFD_LINUX
#include <QComCtrls.hpp>
#endif
//---------------------------------------------------------------------------
// pour asIdentificateurReglePredefinie
#define NBIDENTIFICATEURSREGLEPREDEFINIE 1 // A COMPLETER (lorsque les ensembles ordonns seront implments) : 5
#define IDENTREGLEPREDEFEXCLUSION        1 // A COMPLETER (lorsque les ensembles ordonns seront implments) : 2,3,4,5
//---------------------------------------------------------------------------
#define TAILLEMAXIDENTIFICATEURREGLEPREDEFINIE 2
//---------------------------------------------------------------------------
#define NBTYPESIDENTIFICATEURS 4
//---------------------------------------------------------------------------
enum type_identificateur {tiIndefini, tiRegle, tiVariable, tiElement}; // A COMPLETER (types ordonns) : Entier, Chaine, etc...
enum type_condition {tcIndefini, tcExclusion}; // A COMPLETER (lorsque les ensembles ordonns seront implments) :
// { tcrExclu /* ensembles non ordonns */,
//   tcrMaxExclusMinorants, tcrMinExclusMajorants, tcrMinimum, tcrMaximum /* ensembles ordonns */ };
//-------------------------------------------------------------------------------------------------
/* HIERARCHIE (cration des objets uniquement, rfrences non reprsentes)
---------------- STRUCTURE DE LA BASE --------------------- SYMBOLISATION GRAPHIQUE [COULEUR] -----

         situation           recherche        base                      Cylindre [Jaune]
            / \                  |            / \                      /          |
           /   \                 |      rgles   \                  R() [Bleu]    |
          /     \                |         /      \                  /            |
         V       V               |   signatures    \          R(...) [Violet]     |
inconnues <+   +> conditions     V     /   |  \     |              /     | \      |
    |       \ /       |       dfinitions  |   \    |         ):( [Vert] |  \     |
    |        X        |             /      |    V   V            /       |   \    |
    |       / \       |       contraintes  |     objets      :C [Rouge]  |  T/R/Carr,?,* [Vert][Bleu]
    V      /   \      V              \     V                      \      |
   conditions inconnues de            arguments                 (...) [Rouge][Vert]
  d'inconnues   conditions


*/

class base;
extern base *Base;
extern const char Souligne,
                  SeparateurSignatureContraintes,
                  SeparateurArguments,
                  SeparateurContraintes,
                  SeparateurRegles,
                  DebutListeArguments,
                  FinListeArguments,
                  FinListeRegles,
                  FinQuestion,
                  DebutCommentaire;
extern const AnsiString asVide, asFrmNbSolutions;
//---------------------------------------------------------------------------
template <class SD> class indicateur_recherche
 { // SD sont les initiales des types possibles ([S]ignature|[D]efinition)
  public:
  // Proprits
  AnsiString asCode;
  SD *Crt;
  indicateur_recherche<SD> *Svt;
  // Mthodes
  indicateur_recherche<SD>(const AnsiString asCode, SD *Crt, indicateur_recherche<SD> *Svt)
   {
    this->asCode=asCode;
    this->Crt=Crt; this->Svt=Svt;
   };
  ~indicateur_recherche<SD>() { if (Svt) { delete Svt; Svt=NULL; } };
  SD *CrtCode(const AnsiString asCode, SD *Prm) // Renvoie le <SD> courant de code indiqu. S'il n'a jamais t dfini, renvoie Prm
   {
    if (this->asCode==asCode)
     return Crt;
    else
     if (this->asCode<asCode)
      if (Svt)
       return Svt->CrtCode(asCode, Prm);
      else
       return Prm; // asCode Introuvable, on renvoie Prm
     else
      return Prm; // asCode Introuvable, on renvoie Prm
   };
  void Definit(const AnsiString asCode, SD *Crt)
   {
    if (this->asCode==asCode)
     this->Crt=Crt;
    else
     if ((!Svt)||(asCode<Svt->asCode))
      Svt=new indicateur_recherche<SD>(asCode, Crt, Svt);
     else
      Svt->Definit(asCode, Crt);
   };
  SD *SvtCode(const AnsiString asCode) // Renvoie le <SD> courant  la profondeur indique. Renvoie NULL s'il n'y a pas de suivant
   {
    if (this->asCode==asCode)
     if (Crt&&Crt->Svt)
      return Crt=Crt->Svt;
     else
      return Crt=NULL;
    else
     if (Svt)
      return Svt->SvtCode(asCode);
     else
      return NULL;
   };
  bool CodeAReinitialiser() // return true SI asCode reprsente un fils OU un benjamin OU le fils d'un benjamin du reprsentant de Base->asCodeRacine
   { // Exemples de relation de code : 0110 est un code fils de 011 qui est un code fils de 01 qui est un code fils de 0.
     //                                 012 est un code benjamin de 011 qui est un code benjamin de 010 qui le code fils d'un code benjamin de 00 (code benjamin = 01)
    return ((asCode.Length()>Base->asCodeRacine.Length())&& // Code fils = Taille suprieure ET
            (asCode.AnsiPos(Base->asCodeRacine)==1))|| // Code Racine est un prfixe
           (((Base->asCodeRacine.Length()==1)|| // Code Benjamin ou un de ses fils = [Code Racine de taille 1 OU
             (asCode.AnsiPos(Base->asCodeRacine.SubString(1, Base->asCodeRacine.Length()-1))==1))&& // Code racine -1 car.fin (suffixe) est un prfixe] ET
            (asCode.Length()>=Base->asCodeRacine.Length())&& // Taille suprieure ou gale ET
            (Base->asCodeRacine[Base->asCodeRacine.Length()]<asCode[Base->asCodeRacine.Length()])); // suffixe suprieur (caractre mme position que suffixe code racine)
   };
  void SupprimeSuivant();
  void InitialiseIndicateursRecherche()
   {
    if (!Svt) return;
    if (Svt->CodeAReinitialiser()) SupprimeSuivant();
    if (Svt) Svt->InitialiseIndicateursRecherche();
   }
 };
//---------------------------------------------------------------------------
class objet;
class argument;
class contrainte;
class signature;
class definition;
class regle;
class recherche;
//---------------------------------------------------------------------------
class objet
 {
  void Initialise() { Recherche=NULL; Signature=NULL; Svt=NULL; Type=tiIndefini; };
  public:
  // Accs arborescence (pre*,frre)
  recherche *Recherche;
  signature *Signature;
  objet *Svt;
  // Proprits
  type_identificateur Type;
  AnsiString asIdentificateur;
  // Mthodes
  objet(const AnsiString asIdentificateur, type_identificateur Type)
   {
    Initialise();
    this->asIdentificateur=asIdentificateur;
    this->Type=Type;
   };
  objet(base *Base, const AnsiString asIdentificateur, type_identificateur Type) // Juste une interface de correspondance pour les template (Base est globale)
   {
    Initialise();
    this->asIdentificateur=asIdentificateur;
    this->Type=Type;
   };
  objet(recherche *Recherche, const AnsiString asIdentificateur, type_identificateur Type)
   {
    Initialise();
    this->Recherche=Recherche;
    this->asIdentificateur=asIdentificateur;
    this->Type=Type;
   };
  objet(signature *Signature, const AnsiString asIdentificateur, type_identificateur Type)
   {
    Initialise();
    this->Signature=Signature;
    this->asIdentificateur=asIdentificateur;
    this->Type=Type;
   };
  ~objet() { if (Svt) { delete Svt; Svt=NULL; } };
  bool EstIdentiqueA(objet *Objet) { return Objet&&(Type==Objet->Type)&&(asIdentificateur==Objet->asIdentificateur); };
  objet *AjouteObjet(objet *NvObjet) { if (Svt) return Svt->AjouteObjet(NvObjet); else return Svt=NvObjet; };
  int Nombre(type_identificateur Type) { return (this->Type==Type)+(Svt?Svt->Nombre(Type):0); };
  objet *Objet(const AnsiString asIdentificateur, type_identificateur Type)
   {
    if ((this->asIdentificateur==asIdentificateur)&&
        ((!Type)||(this->Type==Type)))
     return this;
    else
     return Svt?Svt->Objet(asIdentificateur, Type):NULL;
   };
  AnsiString asValeur() { return asIdentificateur; };
 };
//---------------------------------------------------------------------------
class argument
 {
  public:
  // Accs arborescence
  signature *Signature;
  contrainte *Contrainte;
  argument *Svt;
  // Proprits
  AnsiString asIdentificateur; // Sert  lier l'argument  l'objet a posteriori (aprs analyse)
  type_identificateur Type; // Idem : renseigne sur le type du futur objet
  objet *Objet;
  int PosTxtSrc, LgrTxtSrc; // Indique la position et la longueur dans le texte source
  // Mthodes
  argument() { Type=tiIndefini; Signature=NULL; Contrainte=NULL; Svt=NULL; Objet=NULL; LgrTxtSrc=PosTxtSrc=0; };
  ~argument() { if (Svt) { delete Svt; Svt=NULL; } };
  regle *Regle(); // Retourne la rgle correspondante
  bool Identiques(argument *Arguments)
   {
    if (!Arguments)
     return false;
    else
     return (this->asIdentificateur==Arguments->asIdentificateur)&&
            (this->Type==Arguments->Type)&&
            (((!Svt)&&(!Arguments->Svt))||
             (Svt&&Svt->Identiques(Arguments->Svt)));
   };
  template <class S> void ReleveObjets(S *s)
   {
    if (s->ReleveTypeObjet(Type))
     CreeAjouteEtReferenceObjetSiNecessaire(s, &Objet, asIdentificateur, Type);
    if (Signature&&Signature->ReleveTypeObjet(Type))
     CreeAjouteEtReferenceObjetSiNecessaire(Signature, &Objet, asIdentificateur, Type);
    if (Contrainte&&Contrainte->Definition&&Contrainte->Definition->Signature&&Contrainte->Definition->Signature->ReleveTypeObjet(Type))
     CreeAjouteEtReferenceObjetSiNecessaire(Contrainte->Definition->Signature, &Objet, asIdentificateur, Type);
    if (Svt) Svt->ReleveObjets(s);
   };
  AnsiString asArguments();
  void DefinitParents(signature *Signature)
   {
    this->Signature=Signature;
    if (Svt) Svt->DefinitParents(Signature);
   };
  void DefinitParents(contrainte *Contrainte)
   {
    this->Contrainte=Contrainte;
    if (Svt) Svt->DefinitParents(Contrainte);
   };
  int LgrTxtSrcTotale() { return LgrTxtSrc+(Svt?Svt->PosTxtSrc-PosTxtSrc-LgrTxtSrc+Svt->LgrTxtSrcTotale():0); };
 };
//---------------------------------------------------------------------------
class contrainte
 {
  public:
  // Accs arborescence
  definition *Definition;
  contrainte *Svt;
  // Proprits
  argument *Arguments;
  AnsiString asIdentificateurRegle; // Sert  lier la contrainte  la rgle a posteriori (aprs analyse)
  regle *Regle; // Pointe sur la rgle dont l'identificateur correspond
  int PosTxtSrc, LgrTxtSrc; // Indique la position et la longueur dans le texte source
  // Proprits pour la recherche
  indicateur_recherche<signature> *SignatureCrt;
  indicateur_recherche<definition> *DefinitionCrt;
  // Mthodes
  contrainte() { Definition=NULL; Svt=NULL; Arguments=NULL; Regle=NULL; SignatureCrt=NULL; DefinitionCrt=NULL; LgrTxtSrc=PosTxtSrc=0; };
  ~contrainte()
   {
    if (Svt) { delete Svt; Svt=NULL; }
    if (SignatureCrt) { delete SignatureCrt; SignatureCrt=NULL; }
    if (DefinitionCrt) { delete DefinitionCrt; DefinitionCrt=NULL; };
   };
  void AjouteContrainte(contrainte *NvContrainte) // On suppose ici que c'est UNE Contrainte (Svt=NULL)
   {
    if (Svt)
     Svt->AjouteContrainte(NvContrainte);
    else
     Svt=NvContrainte;
   };
  template <class S> void ReleveObjets(S *s);
  AnsiString asContrainte();
  AnsiString asContraintes()
   {
    return asContrainte()+
           (Svt?
            AnsiString(SeparateurContraintes)+Svt->asContraintes():
            asVide);
   }
  void DefinitParents(definition *Definition)
   {
    this->Definition=Definition;
    if (Arguments) Arguments->DefinitParents(this);
    if (Svt) Svt->DefinitParents(Definition);
   };
  void InitialiseIndicateursRecherche();
  void DefinitSignatureCrt(const AnsiString asCode, signature *Signature);
  signature *SignatureCrtCode(const AnsiString asCode, signature *PrmSignature)
   {
    if (SignatureCrt)
     return SignatureCrt->CrtCode(asCode, PrmSignature);
    else
     return PrmSignature;
   };
  void DefinitDefinitionCrt(const AnsiString asCode, definition *Definition);
  definition *DefinitionCrtCode(const AnsiString asCode, definition *PrmDefinition)
   {
    if (DefinitionCrt)
     return DefinitionCrt->CrtCode(asCode, PrmDefinition);
    else
     return PrmDefinition;
   };
  int LgrTxtSrcTotale() { return LgrTxtSrc+(Svt?Svt->PosTxtSrc-PosTxtSrc-LgrTxtSrc+Svt->LgrTxtSrcTotale():0); };
 };
//---------------------------------------------------------------------------
class definition
 {
  public:
  // Accs arborescence
  recherche *Recherche;
  signature *Signature;
  definition *Svt;
  // Proprits
  contrainte *Contraintes; // Pour la recherche
  int PosTxtSrc, LgrTxtSrc; // Indique la position et la longueur dans le texte source
  // Mthodes
  definition() { Recherche=NULL; Signature=NULL; Svt=NULL; Contraintes=NULL; LgrTxtSrc=PosTxtSrc=0; };
  ~definition()
   {
    if (Contraintes) { delete Contraintes; Contraintes=NULL; }
    if (Svt) { delete Svt; Svt=NULL; }
   };
  void AjouteDefinition(definition *NvDefinition) // On suppose ici que c'est UNE Definition (Svt=NULL)
   {
    if (Svt)
     Svt->AjouteDefinition(NvDefinition);
    else
     Svt=NvDefinition;
   };
  void AjouteContrainte(contrainte *NvContrainte)
   {
    if (Contraintes)
     Contraintes->AjouteContrainte(NvContrainte);
    else
     Contraintes=NvContrainte;
   };
  template <class S> void ReleveObjets(S *s);
  AnsiString asContraintes() { return Contraintes?Contraintes->asContraintes():asVide; };
  void DefinitParents(signature *Signature)
   {
    this->Signature=Signature;
    if (Contraintes) Contraintes->DefinitParents(this);
    if (Svt) Svt->DefinitParents(Signature);
   };
  void DefinitParents(recherche *Recherche)
   {
    this->Recherche=Recherche;
    if (Contraintes) Contraintes->DefinitParents(this);
    if (Svt) Svt->DefinitParents(Recherche);
   };
  void InitialiseIndicateursRecherche()
   {
    if (Contraintes) Contraintes->InitialiseIndicateursRecherche();
    if (Svt) Svt->InitialiseIndicateursRecherche();
   };
 };
//---------------------------------------------------------------------------
class signature
 {
  void Initialise() { Regle=NULL; Svt=NULL; Objets=NULL; Arguments=Arguments; Definitions=NULL; };
  public:
  // Accs arborescence
  regle *Regle;
  signature *Svt;
  // Proprits
  objet *Objets;
  argument *Arguments;
  definition *Definitions;
  // Mthodes
  signature(definition *PrmDefinition, argument *Arguments)
   {
    Initialise();
    this->Arguments=Arguments;
    this->Definitions=PrmDefinition;
   };
  ~signature()
   {
    if (Objets) { delete Objets; Objets=NULL; }
    if (Arguments) { delete Arguments; Arguments=NULL; }
    if (Definitions) { delete Definitions; Definitions=NULL; }
    if (Svt) { delete Svt; Svt=NULL; }
   };
  int NombreArite(int NvArite);
  signature *SignatureArite(int NvArite);
  signature *SignatureSvtArite(int NvArite);
  void AjouteSignature(signature *NvSignature) // On suppose ici que c'est UNE Signature (Svt=NULL)
   {
    if (Svt)
     Svt->AjouteSignature(NvSignature);
    else
     Svt=NvSignature;
   };
  signature *Trouve(argument *Arguments)
   {
    if (((!Arguments)&&(!this->Arguments))|| // Aucun arguments des deux cts OU
        ((this->Arguments&&this->Arguments->Identiques(Arguments)))) // Y en a et ce sont les mmes
     return this;
    else
     if (Svt)
      return Svt->Trouve(Arguments);
     else
      return NULL;
   };
  template <class S> void ReleveObjets(S *s);
  AnsiString asSignature();
  bool ReleveTypeObjet(type_identificateur Type)
   {
    switch(Type)
     {
      case tiElement: case tiVariable: return true;
      default: return false;
     }
   };
  void DefinitParents(regle *Regle)
   {
    this->Regle=Regle;
    if (Arguments) Arguments->DefinitParents(this);
    if (Definitions) Definitions->DefinitParents(this);
    if (Svt) Svt->DefinitParents(Regle);
   };
  void InitialiseIndicateursRecherche()
   {
    if (Definitions) Definitions->InitialiseIndicateursRecherche();
    if (Svt) Svt->InitialiseIndicateursRecherche();
   };
 };
//---------------------------------------------------------------------------
class regle
 {
  public:
  // Accs arborescence (pre,frre)
  regle *Svt;
  // Proprits
  type_condition TypeReglePredefinie; // >0 si la rgle est prdfinie, 0 sinon (tcIndefini)
  AnsiString asIdentificateur;
  signature *Signatures;
  // Mthodes
  void Initialise() { Svt=NULL; Signatures=NULL; TypeReglePredefinie=tcIndefini; };
  regle() { Initialise(); };
  regle(type_condition TypeReglePredefinie); // constructeur par rcurrence de rgles prdfinies. v0.3
  ~regle()
   {
    if (Signatures) { delete Signatures; Signatures=NULL; }
    if (Svt) { delete Svt; Svt=NULL; }
   };
  regle *Regle(const AnsiString asIdentificateur)
   {
    if (this->asIdentificateur==asIdentificateur)
     return this;
    else
     return Svt?Svt->Regle(asIdentificateur):NULL;
   };
  void AjouteRegle(regle *NvRegle) // On suppose ici que c'est UNE rgle avec UNE Signature
   {
    if (asIdentificateur==NvRegle->asIdentificateur)
     if (Signatures)
      AjouteSignatures(NvRegle->Signatures); // LA Signature de la nouvelle rgle peut dj exister
     else
      Signatures=NvRegle->Signatures;
    else
     if (Svt)
      Svt->AjouteRegle(NvRegle);
     else
      Svt=NvRegle;
   };
  template <class S> void ReleveObjets(S *s);
  void AjouteDefinition(definition *Definition, argument *Arguments); // Ajoute "Definition"  la rgle dont la signature a pour arguments "Arguments"
  void AjouteSignatures(signature *Signatures)
   {
    if (Signatures)
     AjouteDefinition(Signatures->Definitions, Signatures->Arguments);
   };
  int NombreAritesDifferentes();
  void DefinitParents()
   {
    if (Signatures) Signatures->DefinitParents(this);
    if (Svt) Svt->DefinitParents();
   };
  void InitialiseIndicateursRecherche()
   {
    if (Signatures) Signatures->InitialiseIndicateursRecherche();
    if (Svt) Svt->InitialiseIndicateursRecherche();
   };
 };
//---------------------------------------------------------------------------
class base
 {
  public:
  // Proprits
  objet *Objets;
  regle *Regles;
  AnsiString asCodeRacine;
  // Mthodes
  base() { Regles=NULL; Objets=NULL; };
  ~base()
   {
    if (Regles) { delete Regles; Regles=NULL; }
    if (Objets) { delete Objets; Objets=NULL; }
   };
  void AjouteRegle(regle *NvRegle)
   {
    if (Regles)
     Regles->AjouteRegle(NvRegle);
    else
     Regles=NvRegle;
   };
  void ReleveObjets();
  bool ReleveTypeObjet(type_identificateur Type)
   {
    switch(Type)
     {
      case tiVariable: return false;
      default: return true;
     }
   };
  void DefinitParents() { if (Regles) Regles->DefinitParents(); };
  void InitialiseIndicateursRecherche(const AnsiString asCodeRacine)
   {
    this->asCodeRacine=asCodeRacine;
    if (Regles) Regles->InitialiseIndicateursRecherche();
   };
 };
//---------------------------------------------------------------------------
// Classes de l'arborescence d'une recherche de solutions
//---------------------------------------------------------------------------
class situation;
class condition;
class inconnue;
//---------------------------------------------------------------------------
class inconnue_condition
 {
  void Initialise() { Condition=NULL; Svt=NULL; Inconnue=NULL; };
  public:
  // Accs arborescence (Pre, frres)
  condition *Condition;
  inconnue_condition *Svt;
  // Proprits
  inconnue *Inconnue;
  // Mthodes
  inconnue_condition(condition *Condition, inconnue *Inconnue) { Initialise(); this->Condition=Condition; this->Inconnue=Inconnue; };
  ~inconnue_condition() { if (Svt) { delete Svt; Svt=NULL; } };
  void AjouteInconnue(inconnue *NvInconnue, bool AjoutSiInexistanteSeulement)
   {
    if (AjoutSiInexistanteSeulement&&(NvInconnue==Inconnue)) return; // Existe dj : on fait rien si demand 
    if (Svt)
     Svt->AjouteInconnue(NvInconnue, AjoutSiInexistanteSeulement);
    else
     Svt=new inconnue_condition(Condition, NvInconnue);
   };
  void Enrichit(inconnue_condition *Inconnues); // Ajoute les nouvelles inconnues (Inconnues)
  AnsiString asInconnues();
  AnsiString asResultatInconnues();
 };
//---------------------------------------------------------------------------
class condition_inconnue
 {
  void Initialise() { Inconnue=NULL; Svt=NULL; Condition=NULL; };
  public:
  // Accs arborescence (Pre, frres)
  inconnue *Inconnue;
  condition_inconnue *Svt;
  // Proprits
  condition *Condition;
  // Mthodes
  condition_inconnue(inconnue *Inconnue, condition *Condition) { Initialise(); this->Inconnue=Inconnue; this->Condition=Condition; };
  ~condition_inconnue() { if (Svt) { delete Svt; Svt=NULL; } };
  void AjouteCondition(condition *NvCondition)
   {
    if (Svt)
     Svt->AjouteCondition(NvCondition);
    else
     Svt=new condition_inconnue(Inconnue, NvCondition);
   };
 };
//---------------------------------------------------------------------------
class condition
 {
  void Initialise() { Situation=NULL; Svt=NULL; Possible=true; Inconnues=NULL; };
  public:
  // Accs arborescence (pre,frre)
  situation *Situation;
  condition *Svt;
  // Proprits
  type_condition Type;
  bool Possible; // Stocke le rsultat du premier appel de ToujoursPossibles() si faux
  inconnue_condition *Inconnues;
  // Mthodes
  condition(situation *Situation, type_condition Type)
   {
    Initialise();
    this->Situation=Situation;
    this->Type=Type;
   };
  condition(situation *Situation, condition *ConditionPrc); // Constructeur de copie
  ~condition()
   {
    if (Svt) { delete Svt; Svt=NULL; };
    if (Inconnues) { delete Inconnues; Inconnues=NULL; }
   };
  condition *Condition(type_condition Type)
   {
    if (this->Type==Type)
     return this;
    else
     if (Svt)
      return Svt->Condition(Type);
     else
      return NULL;
   };
  void AjouteCondition(condition *NvCondition)
   {
    if (Svt)
     Svt->AjouteCondition(NvCondition);
    else
     Svt=NvCondition;
   };
  void AjouteInconnue(inconnue *NvInconnue, bool AjoutSiInexistanteSeulement)
   {
    if (!NvInconnue) return; // tolre l'appel AjouteInconnue(NULL, ...)
    if (Inconnues)
     Inconnues->AjouteInconnue(NvInconnue, AjoutSiInexistanteSeulement);
    else
     Inconnues=new inconnue_condition(this, NvInconnue);
   };
  void Enrichit(condition *Condition); // Ajoute chaque condition cre dans Condition qui utilise des variables de this
  bool Possibles(); // Renvoie faux s'il y a au moins une contradiction dans la condition (stocke alors dans Possible)
  bool Utile(); // renvoie faux si toutes les inconnues sont affectes (donc inutile  afficher)
  bool Utiles(); // Idem mais pour this et toutes les conditions suivantes
  AnsiString asCondition();
  AnsiString asConditions()
   {
    return asCondition()+
           (Svt?
            (AnsiString(SeparateurContraintes)+Svt->asConditions()):
            asVide);
   };
  AnsiString asResultatCondition();
  AnsiString asResultatConditions() // Affiche directement les valeurs de variables si elles sont affectes
   {
    return asResultatCondition()+
           (Svt?
            (AnsiString(SeparateurContraintes)+Svt->asResultatConditions()):
            asVide);
   };
  AnsiString asResultatConditionsUtiles()
   {
    if (Utile())
     return  asResultatCondition()+
             (Svt&&Svt->Utiles()?
              (AnsiString(SeparateurContraintes)+Svt->asResultatConditionsUtiles()):
              asVide);
    else
     return (Svt&&Svt->Utiles()?
             Svt->asResultatConditionsUtiles():
             asVide);
   };
 };
//---------------------------------------------------------------------------
class inconnue
 {
  void Initialise()
   {
    LargeurObjet=-1;
    this->Situation=NULL;
    Svt=NULL;
    Variable=NULL;
    Objet=NULL;
    Conditions=NULL;
   };
  public:
  // Accs arborescence (Pre, frres)
  situation *Situation;
  inconnue *Svt;
  // Proprits
  objet *Variable;
  objet *Objet; // Solution trouve (renseigne que si Situation est dfinie, NULL sinon)
  condition_inconnue *Conditions;
  int LargeurObjet; // Largeur lors de l'affectation de la variable (Objet)
  AnsiString asIdentificateurPrc; // Permet de stocker la correspondance avec la variable de la situation prcdente
  // Mthodes
  inconnue(situation *Situation, objet *Variable) { Initialise(); this->Situation=Situation; this->Variable=Variable; };
  inconnue(situation *AncSituation, const argument *AncArguments, situation *NvSituation, argument *NvArguments); // Constructeur de fils
  ~inconnue()
   {
    if (Svt) { delete Svt; Svt=NULL; }
    if (Conditions) { delete Conditions; Conditions=NULL; };
   };
  void AjouteInconnueSiInexistante(objet *Variable)
   {
    if (this->Variable->asIdentificateur!=Variable->asIdentificateur)
     if (Svt)
      Svt->AjouteInconnueSiInexistante(Variable);
     else
      Svt=new inconnue(Situation, Variable);
   };
  void Enrichit(inconnue *Inconnue); // Dfinit les objets si les identificateurs correspondent
  inconnue *Inconnue(const AnsiString asIdentificateur)
   {
    if (Variable->asIdentificateur==asIdentificateur)
     return this;
    else
     if (Svt)
      return Svt->Inconnue(asIdentificateur);
     else
      return NULL;
   };
  inconnue *InconnueIdentificateurPrc(const AnsiString asIdentificateurPrc)
   {
    if (this->asIdentificateurPrc==asIdentificateurPrc)
     return this;
    else
     if (Svt)
      return Svt->InconnueIdentificateurPrc(asIdentificateurPrc);
     else
      return NULL;
   };
  bool ChangeObjetSiVariableAffectee(objet **Variable) // retourne true si Variable a chang (Objet affect par Variable)
   {
    if ((!(*Variable))||((*Variable)->Type!=tiVariable)) return false; // C'est pas une variable on ne fait rien
    if ((*Variable)->asIdentificateur==this->Variable->asIdentificateur) // C'est la mme variable que this->Variable
     if (Objet)
      { // Un objet est affect, on modifie Variable
       (*Variable)=this->Objet;
       return true;
      }
     else
      return false; // Pas la peine de continuer, la variable n'est pas affecte
    else
     if (Svt)
      return Svt->ChangeObjetSiVariableAffectee(Variable); // On va voir les autres inconnues
     else
      return false; // L'inconnue n'a pas t trouve
   };
  void ReinitialiseVariables();
  AnsiString asSolution();
  void AjouteCondition(condition *NvCondition)
   {
    if (Conditions)
     Conditions->AjouteCondition(NvCondition);
    else
     Conditions=new condition_inconnue(this, NvCondition);
   };
  AnsiString asInconnue()
   {
    return Variable->asIdentificateur+
           (Objet?
            AnsiString("["+Objet->asIdentificateur+"]"):
            asVide);
   };
  AnsiString asTrace()
   {
    return (asIdentificateurPrc!=asVide?
            AnsiString(asIdentificateurPrc+"->"):
            asVide)+
           Variable->asIdentificateur+
           (Objet?
            AnsiString("="+Objet->asIdentificateur):
            asVide)+
           (Svt?
            AnsiString(SeparateurArguments)+Svt->asTrace():
            asVide);


   }
  AnsiString asResultatInconnue() { return (Objet?Objet->asIdentificateur:Variable->asIdentificateur); };
 };
//---------------------------------------------------------------------------
class arbre;
//---------------------------------------------------------------------------
class situation
 {
  private: // Ces paramtres ont permis la contruction de l'instance et permettent sa rinitialisation 
  situation *SituationPrc; // Situation de la profondeur suprieure (Profondeur-1)
  argument *ArgumentsPrc; // Arguments de la contrainte prcdente ayant permis l'unification avec ArgumentsSignature
  argument *ArgumentsSignature; // Arguments de la signature d'o vient la contrainte courante en cours d'unification (paramtre de Unifie)
  public:
  // Proprits
  int Profondeur, Largeur;
  AnsiString asCode; // Permet d'identifier de manire absolue la situation dans l'arbre de recherche
  inconnue *Inconnues;
  argument *ArgumentsBut; // Peuvent tre les arguments d'une contrainte ou d'une signature
  condition *Conditions;
  TTreeNode *TreeNodeCrt; // Noeud courant de l'arbre 
  // Mthodes
  void Initialise();
  situation(situation *SituationPrc, argument *ArgumentsSignature, argument *ArgumentsPrc); // Constructeur de fils
  void Reinitialise(argument *ArgumentsBut);
  ~situation()
   {
    if (Inconnues) { delete Inconnues; Inconnues=NULL; }
    if (Conditions) { delete Conditions; Conditions=NULL; }
   };
  void DefinitLargeurSuivante()
   {
    Largeur++;
    asCode[asCode.Length()]=asCode[asCode.Length()]+1;
   };
  void AjouteInconnueSiInexistante(objet *Objet) // Objet doit tre dfini et tre une variable
   {
    if (!Inconnues)
     Inconnues=new inconnue(this, Objet);
    else
     Inconnues->AjouteInconnueSiInexistante(Objet);
   };
  void CompleteInconnuesEtDefinitBut(argument *Arguments); // Complte les inconnues et dfinit comme arguments de but "Arguments"
  void EnrichitInconnuesEtConditions(situation *NvSituation); // Enrichit this des nouveauts de NvSituation (Inconnues & Conditions)
  bool UnifiableAvecArgumentsBut(argument *Arguments); // Pr-requis : Inconnues doit connatre les variables de ArgumentsBut
  AnsiString asSolution();
  // mthodes recurrentes principale de recherche de solutions
  inline bool UnifieContraintesSuivantes(contrainte *Contrainte, bool DerniereContrainteParent);
  bool UnifieReglePredefinie(contrainte *Contrainte);
  bool Unifie(contrainte *Contrainte, bool DerniereContrainteParent);
  void AjouteTraceArbre(int IndexImage, const AnsiString asLibelle, bool NouveauNoeud);
  void AjouteCondition(condition *NvCondition)
   {
    if (!Conditions)
     Conditions=NvCondition;
    else
     Conditions->Svt->AjouteCondition(NvCondition);
   };
  bool ConditionsPossibles() { if (Conditions) return Conditions->Possibles(); else return true; };
  AnsiString asConditions() { return Conditions?Conditions->asConditions():asVide; };
  AnsiString asResultatConditions() { return Conditions?Conditions->asResultatConditions():asVide; };
  AnsiString asResultatConditionsUtiles() { return Conditions?Conditions->asResultatConditionsUtiles():asVide; };
  AnsiString asTraceInconnues() { if (Inconnues) return Inconnues->asTrace(); else return asVide; };
  bool PasseSignatureDefinitionSvteDrnContrainte(contrainte *Contrainte, const AnsiString asCode);
 };
//---------------------------------------------------------------------------
class recherche
 {
  private:
  TStrings *slSortie;
  public:
  // Proprits
  int NbSolutions;
  bool Trace; // Indique si le noeud Trace de l'arbre de Recherche est aliment
  objet *Objets;
  AnsiString asQuestion;
  definition *Question;
  arbre *Arbre; // Seul arbre qui est dtruit dans le destructeur car la recherche le met  jour au fur et  mesure
  TTreeNode *TreeNodeSolutions; // Noeud pour afficher les solutions
  TTreeNode *TreeNodeTrace; // Noeud courant pour la trace pendant la recherche
  // Mthodes
  recherche(const AnsiString asQuestion)
   {
    NbSolutions=0;
    Trace=false;
    this->Objets=NULL;
    this->asQuestion=asQuestion;
    this->Question=new definition;
    this->Arbre=NULL; // Instanci au moment de la cration de l'arbre
    this->TreeNodeSolutions=NULL; // Rfrenc lorsque le noeud sera cr puis utilis
    this->TreeNodeTrace=NULL; // Rfrenc lorsque le noeud sera cr puis utilis
   };
  ~recherche()
   {
    if (Question) { delete Question; Question=NULL; }
    if (Arbre) { delete Arbre; Arbre=NULL; };
   };
  void ReleveObjets();
  bool ReleveTypeObjet(type_identificateur Type)
   {
    switch(Type)
     {
      case tiElement: case tiVariable: return true;
      default: return false;
     }
   };
  void DefinitParents() { if (Question) Question->DefinitParents(this); };
  AnsiString asNbSolutions() { return Format(asFrmNbSolutions, ARRAYOFCONST((NbSolutions))); };
  void AjouteSolution(situation *Situation);
  bool Cherche(TStrings *slSortie, bool Trace, bool StopApresPremiereSolution);
 };
//---------------------------------------------------------------------------
extern recherche *Recherche;
extern objet VariableTemporaire;
extern regle ReglesPredefinies;
extern const AnsiString asListeArgumentsVide,
                        asIdentificateurReglePredefinie[NBIDENTIFICATEURSREGLEPREDEFINIE+1];
//---------------------------------------------------------------------------
#endif
